// csvdlg.cpp : implementation file
//

#include "stdafx.h"
#include "csvdlg.h"
#include <windows.h>


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

sQCKMARKER::sQCKMARKER()
{
}

/////////////////////////////////////////////////////////////////////////////
// csvdlg dialog


csvdlg::csvdlg(CWnd* pParent /*=NULL*/)
	: CDialog(csvdlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(csvdlg)
	//}}AFX_DATA_INIT

    m_Draw = false;
}


void csvdlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(csvdlg)
	DDX_Control(pDX, IDC_DELAY, m_delay);
	DDX_Control(pDX, IDC_MARGIN, m_zoommargin);
	DDX_Control(pDX, IDC_THICKNESS, m_thickness);
	DDX_Control(pDX, IDC_MARKSIZE, m_marksize);
	DDX_Control(pDX, IDC_SHAPELIST, m_ShapeList);
	DDX_Control(pDX, IDC_CSVDSP, m_listwin);
	DDX_Control(pDX, IDC_INFILEDSP, m_infiledsp);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(csvdlg, CDialog)
	//{{AFX_MSG_MAP(csvdlg)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	ON_NOTIFY(NM_CLICK, IDC_CSVDSP, OnClickCsvdsp)
	ON_BN_CLICKED(IDC_CLEAR, OnClear)
	ON_WM_HSCROLL()
	ON_EN_CHANGE(IDC_THICKNESS, OnChangeThickness)
	ON_CBN_SELCHANGE(IDC_SHAPELIST, OnSelchangeShapelist)
	ON_WM_SHOWWINDOW()
	ON_BN_CLICKED(IDC_COLORDIALOG, OnColordialog)
	ON_WM_CTLCOLOR()
	ON_BN_CLICKED(IDC_FIRST, OnFirst)
	ON_BN_CLICKED(IDC_LAST, OnLast)
	ON_BN_CLICKED(IDC_PLAYFORWARD, OnPlayforward)
	ON_BN_CLICKED(IDC_PLAYBACKWARD, OnPlaybackward)
	ON_BN_CLICKED(IDC_PRECURLAY, OnPrecurlay)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// csvdlg message handlers

///////////////////////////////////////Dialog Initialization//////////////////////////////////////////////////////////

BOOL csvdlg::OnInitDialog() 
{
  CDialog::OnInitDialog();

//Registering for QckServices
  m_WindowSrvc = m_Manager->RegisterForWindowService();;
  m_GraphicsSrvc = m_Manager->RegisterForGraphicsService();
  m_DatabaseSrvc = m_Manager->RegisterForDatabaseService();
  m_ExtractSrvc = m_Manager->RegisterForExtractService();
  m_LayerSrvc = m_Manager->RegisterForLayerService();
  m_MarkerSrvc = m_Manager->RegisterForMarkerService();


//To Select an entire row in the list control box
  m_listwin.ModifyStyle(0, LVS_REPORT, NULL);
  m_listwin.SetExtendedStyle(LVS_EX_FULLROWSELECT | LVS_EX_INFOTIP | LVS_EX_ONECLICKACTIVATE | LVS_EX_GRIDLINES);

 //Various columns in the list control box to display CSV

  RECT rect;
  m_listwin.GetWindowRect(&rect);
  int width = (rect.right - rect.left) / 3;
  m_listwin.InsertColumn(0, "Cell", LVCFMT_LEFT, width);  
  m_listwin.InsertColumn(1, "Layer",   LVCFMT_LEFT, width);
  m_listwin.InsertColumn(2, "Coordinates",  LVCFMT_LEFT, width);

	
//Default marker values
  marker.mShape = NQckPlugin::markerShapeBOXEDX; //Default shape
  marker.mRGB[0] =  0;
  marker.mRGB[1] =  0; //Default color: black
  marker.mRGB[2] =  0;
  marker.mSize = 30; //Size
  marker.mThickness = 3; //Thickness

  m_marksize.SetScrollRange(0, 200); //marker size range
  m_ShapeList.SetWindowText("BoxedX");
  m_zoommargin.SetWindowText("50");
  m_thickness.SetWindowText("3");
  
//Delay

  m_delay.SetWindowText("2");
  
//Marker shapes in the drop-down combo box
  m_ShapeList.AddString("Cross");
  m_ShapeList.AddString("Diamond");
  m_ShapeList.AddString("X");
  m_ShapeList.AddString("Square");
  m_ShapeList.AddString("Triangle");
  m_ShapeList.AddString("BoxedX");
  m_ShapeList.AddString("RTriangle");
  m_ShapeList.AddString("Boxed Cross"); 

  m_ShapeList.SelectString(-1, "Cross");

  m_DatabaseSrvc->SetDatabaseServiceNotify(m_Handle,this);
  m_LayerSrvc->SetLayerServiceNotify(m_Handle,this);
  m_WindowSrvc->SetWindowServiceNotify(m_Handle, this);
  m_GraphicsSrvc->SetDrawServiceNotify(m_Handle, this);

//Flags
  m_Draw = false; //For drawing marker       
  m_fileloaded = false; //For loading CSV file
  keepcurlay = false; //To "preserve current layers"
  stop = false;  //To STOP forward and backward selection
  
  


	UpdateData(FALSE);	

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


// Show dialog notice from Qckvu

void csvdlg::OnShowDialog(const bool show) 
{

// Move dialog on/off screen during qislib redraw

  CRect rect;
  GetWindowRect(&rect);
  if(show) {
    rect.left-=3000;
    rect.right-=3000;
  } else {
    rect.left+= 3000;
    rect.right+= 3000;
  }
  MoveWindow(&rect);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////Loading CSV File in the List Box////////////////////////////////////////////////

//BROWSE to select a CSV file

void csvdlg::OnBrowse() 
{

	this->UpdateData();
	
	CFile searchForCSV;
	CString filePath;

	char strFilter[] = { "CSV Files (*.csv)|*.csv|All Files (*.*)|*.*||" };

	CFileDialog FileDlg(TRUE, ".csv", NULL, OFN_HIDEREADONLY, strFilter);

	if( FileDlg.DoModal() == IDOK )
	{
		filePath = FileDlg.GetPathName();
		m_infiledsp.SetWindowText(_T(filePath)); //display file path 

		if( searchForCSV.Open(FileDlg.GetFileName(), CFile::modeRead) == FALSE )
		return;
		m_fileloaded = true;
		
		CArchive ar(&searchForCSV, CArchive::load);

		char *token;
		
		CString strLine;
		CString coordx;
		CString coordy;
		CString coord;
		
		int subColumn=1;
	

//to parse and load the csv file into the list box display		
		
		for( int row=0;row != EOF;row++)  
		{	
			ar.ReadString(strLine);
			if(strLine == "") break;
			token = strtok((char *) strLine.operator LPCTSTR(), ",");
			m_listwin.InsertItem(row,token); //cell name
			token = strtok( NULL, "," );
			m_listwin.SetItemText(row,subColumn,token); //layers
			subColumn++;
			coordx = (LPCSTR) strtok( NULL, "," );
			coordy = (LPCSTR) strtok( NULL, "," );
			coord = coordx+","+coordy;
			if(coord != ",")
			m_listwin.SetItemText(row,subColumn,coord); //coordinates
			subColumn=1;
			

		}

			ar.Close();  

		} 
		
		
		else
		return;

		searchForCSV.Close();
	
		this->UpdateData(FALSE);
}
	
//////////////////////////////////////////////Selecting a Particular Row in the list box////////////////////////////////////////////////

// Invoked when clicked anywhere in the csv list box, selecting that entire row

void csvdlg::OnClickCsvdsp(NMHDR* pNMHDR, LRESULT* pResult) 
{

	m_Draw = true;
	
	pos = m_listwin.GetFirstSelectedItemPosition(); //get position of the selected item
	posint = int (pos);
	posint--;
	CString CellName = m_listwin.GetItemText(posint,0); //get cell name
	CString layers = m_listwin.GetItemText(posint,1); //get layers
	CString coordinates = m_listwin.GetItemText(posint,2);
	const char* CellNameChar = (LPCSTR) CellName;
	const char* layerschar = (LPCSTR) layers;
	const char* coordinateschar = (LPCSTR) coordinates;

	PutMarkerOnScreen(layerschar,CellNameChar,coordinateschar);

    *pResult = 0;
}

/////////////////////////////////////////////////Marker Properties///////////////////////////////////////////////////////////////

//On marker color change

	void csvdlg::OnColordialog() 
{

		 CColorDialog dlg; //Open color dialog
     if (dlg.DoModal() == IDOK) {
			 colordlg = dlg.GetColor(); 
		   marker.mRGB[0] =  GetRValue(colordlg); //get RGB values
		   marker.mRGB[1] =  GetGValue(colordlg);
		   marker.mRGB[2] =  GetBValue(colordlg);
		   this->Invalidate(TRUE);
		   if(m_Draw) {
		     m_GraphicsSrvc->Redraw(true);          
		   }
     }
}


//Horizontal scroll for varying Maker Size

void csvdlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{


	int marksizeint = m_marksize.GetScrollPos();
	marker.mSize = marksizeint;          //get new marker size and redraw marker
	if(m_Draw) {
	  m_GraphicsSrvc->Redraw(true);
	}
	

	// Determine the new position of scroll box.
	switch (nSBCode)
	{
		case SB_LEFT:      // Scroll to far left.
			marksizeint = 0;
			break;

		case SB_RIGHT:      // Scroll to far right.
			marksizeint = 100;
			break;

		case SB_ENDSCROLL:   // End scroll.
			break;

		case SB_LINELEFT:      // Scroll left.
			if (marksizeint > 0)
				marksizeint--;
			break;

		case SB_LINERIGHT:   // Scroll right.
			if (marksizeint < 100)
				marksizeint++;
			break;

		case SB_THUMBPOSITION: // Scroll to absolute position. nPos is the position
			marksizeint = nPos;      // of the scroll box at the end of the drag operation.
			break;

		case SB_THUMBTRACK:   // Drag scroll box to specified position. nPos is the
			marksizeint = nPos;     // position that the scroll box has been dragged to.
			break;
	}


	m_marksize.SetScrollPos(marksizeint);


	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}


void csvdlg::OnChangeThickness() 
{
	
    CString markervalue;
    m_thickness.GetWindowText(markervalue); //get new thickness value from user
    unsigned short MarkerSiz = atoi(markervalue);
	marker.mThickness = MarkerSiz;
	if(m_Draw) {
		m_GraphicsSrvc->Redraw(true);
	}
}


//Invoked when a new marker shape is selected

void csvdlg::OnSelchangeShapelist() 
{

	int iSel= m_ShapeList.GetCurSel(); 
     
    CString MarkShape; m_ShapeList.GetLBText(iSel,MarkShape);  //get the selected shape

	if(MarkShape=="Boxed Cross")
	  marker.mShape = NQckPlugin::markerShapeBOXEDCROSS;   //redraw marker
	else if( MarkShape == "BoxedX")
	  marker.mShape = NQckPlugin::markerShapeBOXEDX;
	else if(MarkShape== "Cross")
	  marker.mShape = NQckPlugin::markerShapeCROSS;
	else if(MarkShape == "Diamond")
	  marker.mShape = NQckPlugin::markerShapeDIAMOND;
	else if(MarkShape== "RTriangle")
	  marker.mShape = NQckPlugin::markerShapeRTRIANGLE;
	else if(MarkShape == "Square")
	  marker.mShape = NQckPlugin::markerShapeSQUARE;
	else if(MarkShape == "Triangle")
	  marker.mShape = NQckPlugin::markerShapeTRIANGLE;
	else if(MarkShape == "X")
	  marker.mShape = NQckPlugin::markerShapeX;

	if(m_Draw) {
		m_GraphicsSrvc->Redraw(true);
	}
}

void csvdlg::OnClear() 
{

	m_listwin.DeleteAllItems();          //clear items in the list box
	m_infiledsp.SetWindowText(_T(""));   //clear file path

// Erase marker
  
	m_Draw = false;
	m_fileloaded = false;
	stop = false;
	m_GraphicsSrvc->Redraw(true);
	KillTimer(1);
	KillTimer(2);
}




void csvdlg::OnCancel() 
{

	ShowWindow(SW_HIDE);
	CDialog::OnCancel();

// Erase marker

	m_GraphicsSrvc->Redraw(true);
	KillTimer(1);
	KillTimer(2);
}


void csvdlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{

	CDialog::OnShowWindow(bShow, nStatus);
	
	if(bShow) {
		m_GraphicsSrvc->SetDrawServiceNotify(m_Handle, this);
	} else {
		m_GraphicsSrvc->SetDrawServiceNotify(m_Handle, NULL);
	}
}

/////////////////////////////////////////////////////////////////////////////
// Redraw notice from Qckvu

void csvdlg::OnRedraw()
{

  if(m_Draw)
	  m_MarkerSrvc->DrawMarker(marker);
}

HBRUSH csvdlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

// Check control ID

	switch(pWnd->GetDlgCtrlID()) {
		case  IDC_COLORDIALOG: {
			CRect rect;
			pWnd->GetClientRect(&rect);
			pDC->FillSolidRect(&rect, RGB(marker.mRGB[0], marker.mRGB[1], marker.mRGB[2]));
			break;
		}
	}

	return hbr;
}

void csvdlg::OnFirst() 
{

  if(m_fileloaded) {
	m_Draw = true;
	posint = 0;
	
	CString CellName = m_listwin.GetItemText(0,0);	
	CString layers = m_listwin.GetItemText(0,1); //get layers
	CString coordinates = m_listwin.GetItemText(0,2);
	const char* CellNameChar = (LPCSTR) CellName;
	const char* layerschar = (LPCSTR) layers;
	const char* coordinateschar = (LPCSTR) coordinates;
	

	PutMarkerOnScreen(layerschar,CellNameChar,coordinateschar);

	
	}
	else
		AfxMessageBox(_T("Please Load a CSV file."));
	
}

void csvdlg::OnLast() 
{
	if(m_fileloaded) {

		m_Draw = true;
		posint = m_listwin.GetItemCount()-1;
		
		CString CellName = m_listwin.GetItemText(m_listwin.GetItemCount()-1,0);	
		CString layers = m_listwin.GetItemText(m_listwin.GetItemCount()-1,1); //get layers
		CString coordinates = m_listwin.GetItemText(m_listwin.GetItemCount()-1,2);
		const char* CellNameChar = (LPCSTR) CellName;
		const char* layerschar = (LPCSTR) layers;
		const char* coordinateschar = (LPCSTR) coordinates;
		
		PutMarkerOnScreen(layerschar,CellNameChar,coordinateschar);
		
	}
		else
		AfxMessageBox(_T("Please Load a CSV file."));
	
}

//Play forward
void csvdlg::OnPlayforward() 
{
	if(m_fileloaded) {     //check to see if CSV file loaded or not, give out a message otherwise
		m_Draw = true;     //enable drawing of marker 
		
		CString delay_val;
		m_delay.GetWindowText(delay_val); //get delay value from user
		if(delay_val != ""){              //give out a message if delay field is left blank
			double delay_value = atof(delay_val);
			pos = m_listwin.GetFirstSelectedItemPosition(); //get position of the selected item
			posint = int (pos);
			stop = false; 
			KillTimer(2);
			SetTimer(1,delay_value*1000,0 );
			
		}
		else
			AfxMessageBox(_T("Enter Delay (in seconds)"));
		
	}
		else
			AfxMessageBox(_T("Please Load the CSV file."));
		
		
}



void csvdlg::OnPlaybackward() 
{
	if(m_fileloaded) {     //check to see if CSV file loaded or not, give out a message otherwise
		m_Draw = true;     //enable drawing of marker 
		CString delay_val;
		m_delay.GetWindowText(delay_val); //get delay value from user
		if(delay_val != ""){              //give out a message if delay field is left blank
			double delay_value = atof(delay_val);
			pos = m_listwin.GetFirstSelectedItemPosition(); //get position of the selected item
			posint = int (pos);
			if(posint == 0) posint = m_listwin.GetItemCount()-1; //when nothing is selected
			else {
					posint--;
					if(posint == 0 ) posint = m_listwin.GetItemCount()-1; //when the first item is selected
			}
			stop = false;
			KillTimer(1);
			SetTimer(2,delay_value*1000,0 );
			
		}
		else
			AfxMessageBox(_T("Enter Delay (in seconds)"));
		
	}
	else
		AfxMessageBox(_T("Please Load the CSV file."));
	
}

void csvdlg::OnPrecurlay() 
{
	if(!keepcurlay) keepcurlay = true;
	else keepcurlay = false;
	
}




void csvdlg::OnStop() 
{
	stop = true;
	KillTimer(1);
	KillTimer(2);
	
}



void csvdlg::OnTimer(UINT nIDEvent) 
{
	
		switch(nIDEvent)
		{
			
			case 1:
				{	while(posint < m_listwin.GetItemCount() && stop == false && nIDEvent == 1) {
						m_listwin.SetItemState(posint, LVIS_SELECTED, LVIS_SELECTED | LVIS_FOCUSED);
						m_listwin.EnsureVisible(posint, FALSE);
						CString CellName = m_listwin.GetItemText(posint,0); //get cell name
						CString layers = m_listwin.GetItemText(posint,1); //get layers
						CString coordinates = m_listwin.GetItemText(posint,2);
						const char* CellNameChar = (LPCSTR) CellName;
						const char* layerschar = (LPCSTR) layers;
						const char* coordinateschar = (LPCSTR) coordinates;
						PutMarkerOnScreen(layerschar,CellNameChar,coordinateschar);
					
						posint++;
						nIDEvent = 0;
					}
						
					if(posint==m_listwin.GetItemCount()) OnStop(); //kill timer 
				}

			case 2:
				{	while(posint >= 0 && stop == false && nIDEvent == 2) {
						m_listwin.SetItemState(posint, LVIS_SELECTED, LVIS_SELECTED | LVIS_FOCUSED);
						m_listwin.EnsureVisible(posint, FALSE);
						CString CellName = m_listwin.GetItemText(posint,0); //get cell name
						CString layers = m_listwin.GetItemText(posint,1); //get layers
						CString coordinates = m_listwin.GetItemText(posint,2);
						const char* CellNameChar = (LPCSTR) CellName;
						const char* layerschar = (LPCSTR) layers;
						const char* coordinateschar = (LPCSTR) coordinates;
						PutMarkerOnScreen(layerschar,CellNameChar,coordinateschar);
						posint--;
						nIDEvent = 0;
					}

					if(posint==-1) OnStop(); //kill timer

				}
				
		}

		

	CDialog::OnTimer(nIDEvent);
}

void csvdlg::PutMarkerOnScreen(const char* layerschar,const char* CellNameChar, const char* coordinateschar)
{

	CString layers =  (LPCSTR)layerschar;
	CString CellName = (LPCSTR)CellNameChar;
	CString coordinates = (LPCSTR)coordinateschar;

	m_listwin.SetItemState(posint, LVIS_SELECTED, LVIS_SELECTED | LVIS_FOCUSED);
	m_listwin.EnsureVisible(posint, TRUE);
	

	const char *cur_cell = m_DatabaseSrvc->GetViewCell();
	if(strcmp(cur_cell, CellName) != 0) {
		m_DatabaseSrvc->SetViewCell(CellName,true);
	}

	
	char* token;
	
	if(!keepcurlay) {         //Check preserve current layers
		if(stricmp(layers, "ALL") == 0) {
			m_LayerSrvc->SetAllLayersOnOff(true,false); //trun-on all layers
		}

		else
		{
			m_LayerSrvc->SetAllLayersOnOff(false,false);
			token = strtok((char *) layers.operator LPCTSTR(), ";");
			for(;token != NULL;) {
			
				CString teststr = (LPCSTR) token;
				teststr=teststr+":0";
				m_LayerSrvc->SetLayerOnOff(teststr,true,false); //turn-off specific layers
				token = strtok(NULL, ";");
				teststr="";
			}
		
		} 
	}
	
	
	
	char* coordtok;
	coordtok = strtok((char *) coordinates.operator LPCTSTR(), ","); //get coordinates
	CString tokX = (LPCSTR)coordtok;
	coordtok = strtok(NULL, ",");
	CString tokY = (LPCSTR)coordtok;

	double X = atof(tokX); //convert coordinates to double 
	double Y = atof(tokY);

    marker.mXY[0] = X; 
    marker.mXY[1] = Y;

    CString Margin;
	
	m_zoommargin.GetWindowText(Margin); //get margin value to be set
	double MarginExts = atoi(Margin);

    m_MarkerSrvc->ZoomToMarker(marker,MarginExts,MarginExts,false);
    m_GraphicsSrvc->Redraw(true);


}




